pipeline {
    agent {
        kubernetes {
            label 'slave'
            yamlFile 'build-pod.yaml'
            defaultContainer 'ez-docker-helm-build'
        }
    }

    environment {
        DOCKER_IMAGE_NAME = "itsvictorfy/final-proj"
        DOCKER_IMAGE_TAG = "${env.GIT_COMMIT.take(7)}"
        DOCKERHUB_USERNAME = credentials('victor_dockerhub_username')
        DOCKERHUB_PASS = credentials('victor_dockerhub_pass')
        GITHUB_AT = credentials('github_access_token')
        CHART_VERSION = "1.0-${DOCKER_IMAGE_TAG}"
        GITHUB_EMAIL = credentials('github_email')
    }

    stages {
        stage('Build Docker Image') {
            steps {
                script {
                    echo "test"
                    sh "docker build -t ${DOCKER_IMAGE_NAME}:${DOCKER_IMAGE_TAG} ."
                    sh "sed -i 's/tag: .*/tag: ${DOCKER_IMAGE_TAG}/' helm-chart/values.yaml"
                    sh "sed -i 's/namespace: .*/namespace: ${BRANCH_NAME}/' helm-chart/values.yaml"
                }
            }
        }
        stage('Build Helm Chart') {
            steps {
                sh "sed -i 's/tag: .*/tag: ${DOCKER_IMAGE_TAG}/' helm-chart/values.yaml"
                sh "helm package helm-chart/ -d helm-chart/ --version ${CHART_VERSION}"
            }
        }

        stage('Docker & Helm Login and Push') {
            steps {
                script {
                    sh "docker login -u ${DOCKERHUB_USERNAME} -p ${DOCKERHUB_PASS}"
                    sh "docker push ${DOCKER_IMAGE_NAME}:${DOCKER_IMAGE_TAG}"
                    sh "helm push helm-chart/finalproj-db-${CHART_VERSION}.tgz oci://registry-1.docker.io/itsvictorfy"
                }
            }
        }
        stage('Update Helm Values') {
            steps {
                script {
                    echo "Performing actions for the master branch..."
                    sh "git config --global user.email ${GITHUB_EMAIL}"
                    sh "git config --global user.name ${DOCKERHUB_USERNAME}"
                    sh "git clone https://${DOCKERHUB_USERNAME}:${GITHUB_AT}@github.com/${DOCKERHUB_USERNAME}/finalproj-argo.git"
                    dir('finalproj-argo') {
                        sh "sed -i 's/imageTag: .*/imageTag: ${DOCKER_IMAGE_TAG}/' db/helm-chart/values.yaml"
                        sh "git add ."
                        sh "git commit -m 'Update Image Tag ${DOCKER_IMAGE_TAG}'"
                        sh "git push"
                    }   
                }
            }
        }
    }
}
